'use strict';

var _expect = require('expect');

var _expect2 = _interopRequireDefault(_expect);

var _nested = require('../nested');

var _nested2 = _interopRequireDefault(_nested);

var _NestedSelector = require('../../models/NestedSelector');

var _NestedSelector2 = _interopRequireDefault(_NestedSelector);

var _RuleSet = require('../../models/RuleSet');

var _RuleSet2 = _interopRequireDefault(_RuleSet);

var _ValidRuleSetChild = require('../../models/ValidRuleSetChild');

var _ValidRuleSetChild2 = _interopRequireDefault(_ValidRuleSetChild);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('nested', function () {
	it('should return a NestedSelector', function () {
		var result = (0, _nested2.default)();
		(0, _expect2.default)(result).toBeA(_NestedSelector2.default);
	});

	it('should add the selector', function () {
		var selector = '> *';
		var result = (0, _nested2.default)(selector);
		(0, _expect2.default)(result.selector).toEqual(selector);
	});

	it('should have a RuleSet', function () {
		var rule = new _ValidRuleSetChild2.default();
		var result = (0, _nested2.default)(undefined, rule);
		(0, _expect2.default)(result.ruleSet).toBeA(_RuleSet2.default);
	});

	it('should add a rule to the RuleSet', function () {
		var rule = new _ValidRuleSetChild2.default();
		var result = (0, _nested2.default)(undefined, rule);
		(0, _expect2.default)(result.ruleSet.rules).toEqual([rule]);
	});

	it('should add multiple rules to the RuleSet', function () {
		var rule1 = new _ValidRuleSetChild2.default();
		var rule2 = new _ValidRuleSetChild2.default();
		var result = (0, _nested2.default)(undefined, rule1, rule2);
		(0, _expect2.default)(result.ruleSet.rules).toEqual([rule1, rule2]);
	});
});