'use strict';

var _expect = require('expect');

var _expect2 = _interopRequireDefault(_expect);

var _pseudo = require('../pseudo');

var _pseudo2 = _interopRequireDefault(_pseudo);

var _NestedSelector = require('../../models/NestedSelector.js');

var _NestedSelector2 = _interopRequireDefault(_NestedSelector);

var _ValidRuleSetChild = require('../../models/ValidRuleSetChild.js');

var _ValidRuleSetChild2 = _interopRequireDefault(_ValidRuleSetChild);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('pseudo', function () {
  it('should return a NestedSelector', function () {
    var result = (0, _pseudo2.default)('');
    (0, _expect2.default)(result).toBeA(_NestedSelector2.default);
  });

  it('should prefix an ampersand', function () {
    var result = (0, _pseudo2.default)('after');
    (0, _expect2.default)(result.selector).toEqual('&:after');
  });

  it('should handle multiple selectors', function () {
    var result = (0, _pseudo2.default)('after,before');
    (0, _expect2.default)(result.selector).toEqual('&:after,&:before');
  });

  it('should handle spaces', function () {
    var result = (0, _pseudo2.default)('after, before');
    (0, _expect2.default)(result.selector).toEqual('&:after,&:before');
  });

  it('should add a rule', function () {
    var rule = new _ValidRuleSetChild2.default();
    var result = (0, _pseudo2.default)('after,before', rule);
    (0, _expect2.default)(result.ruleSet.rules).toEqual([rule]);
  });

  it('should multiple rules', function () {
    var rule1 = new _ValidRuleSetChild2.default();
    var rule2 = new _ValidRuleSetChild2.default();
    var result = (0, _pseudo2.default)('after,before', rule1, rule2);
    (0, _expect2.default)(result.ruleSet.rules).toEqual([rule1, rule2]);
  });
});