'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _concat = require('./concat');

var _concat2 = _interopRequireDefault(_concat);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

exports.default = function (name, definitions, cb) {
  var flatDefinitions = {};
  var _throw = function _throw(message) {
    throw new Error(message + '\nValid values for \'' + name + '\' are:\n' + Object.keys(flatDefinitions).join('\n'));
  };
  Object.keys(definitions).forEach(function (category) {
    Object.keys(definitions[category]).forEach(function (option) {
      if (option === 'default') return;
      if (flatDefinitions[option]) _throw('Already have a definition for \'' + option + '\' as a \'' + flatDefinitions[option].category + '\'!');
      flatDefinitions[option] = { category: category, option: option, value: definitions[category][option] };
    });
  });
  return function () {
    var valueString = arguments.length <= 0 || arguments[0] === undefined ? '' : arguments[0];

    var values = valueString.split(/ +/);
    var obj = {};
    values.filter(function (x) {
      return x;
    }).forEach(function (v) {
      var definition = flatDefinitions[v];
      if (!definition) _throw('Unknown value \'' + v + '\' for ' + name + '.');
      var category = definition.category;

      if (obj[category]) _throw('More than one \'' + category + ' specified for ' + name + ': encountered \'' + v + '\' but already had seen \'' + obj[category].option + '\'.');
      obj[category] = definition;
    });
    Object.keys(definitions).forEach(function (category) {
      if (typeof obj[category] === 'undefined') {
        if (typeof definitions[category].default === 'undefined') _throw('No provided value for category \'' + category + '\' and no default specified.');
        obj[category] = definitions[category].default;
      } else {
        obj[category] = obj[category].value;
      }
    });
    return cb ? cb(obj) : _concat2.default.apply(undefined, _toConsumableArray(Object.keys(obj).map(function (k) {
      return obj[k];
    })));
  };
};

module.exports = exports['default'];