'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.pseudo = exports.media = exports.trait = exports.toggle = exports.simple = exports.css = exports.concat = exports.nested = exports.units = exports.rules = exports.rule = exports.elem = undefined;

var _Element = require('./models/Element');

var _Element2 = _interopRequireDefault(_Element);

var _Root = require('./models/Root');

var _Root2 = _interopRequireDefault(_Root);

var _rules = require('./rules');

var rules = _interopRequireWildcard(_rules);

var _units = require('./units');

var units = _interopRequireWildcard(_units);

var _concat = require('./constructors/concat');

var _concat2 = _interopRequireDefault(_concat);

var _css = require('./constructors/css');

var _css2 = _interopRequireDefault(_css);

var _rule = require('./constructors/rule');

var _rule2 = _interopRequireDefault(_rule);

var _simple = require('./constructors/simple');

var _simple2 = _interopRequireDefault(_simple);

var _toggle = require('./constructors/toggle');

var _toggle2 = _interopRequireDefault(_toggle);

var _trait = require('./constructors/trait');

var _trait2 = _interopRequireDefault(_trait);

var _media = require('./constructors/media');

var _media2 = _interopRequireDefault(_media);

var _nested = require('./constructors/nested');

var _nested2 = _interopRequireDefault(_nested);

var _pseudo = require('./constructors/pseudo');

var _pseudo2 = _interopRequireDefault(_pseudo);

var _styled = require('./constructors/styled');

var _styled2 = _interopRequireDefault(_styled);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/* Two main entry points */


/* Higher-order constructors */


/* Wrap the base functions in objects and export*/
var elem = _Element2.default;
var generateClassnames = function generateClassnames() {
  for (var _len = arguments.length, rules = Array(_len), _key = 0; _key < _len; _key++) {
    rules[_key] = arguments[_key];
  }

  return new (Function.prototype.bind.apply(_Root2.default, [null].concat(rules)))().injectStyles();
};

exports.elem = elem;
exports.rule = _rule2.default;
exports.rules = rules;
exports.units = units;
exports.nested = _nested2.default;
exports.concat = _concat2.default;
exports.css = _css2.default;
exports.simple = _simple2.default;
exports.toggle = _toggle2.default;
exports.trait = _trait2.default;
exports.media = _media2.default;
exports.pseudo = _pseudo2.default;
exports.default = _styled2.default;