'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _Root = require('./Root');

var _Root2 = _interopRequireDefault(_Root);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

/* Either ['tagName', ...styles] or [...styles] can be passed in */
var ensureTagThenStyles = function ensureTagThenStyles(list) {
  return typeof list[0] === 'string' ? list : ['div'].concat(list);
};

var Element = function Element() {
  for (var _len = arguments.length, properties = Array(_len), _key = 0; _key < _len; _key++) {
    properties[_key] = arguments[_key];
  }

  var _ensureTagThenStyles = ensureTagThenStyles(properties);

  var _ensureTagThenStyles2 = _toArray(_ensureTagThenStyles);

  var tagName = _ensureTagThenStyles2[0];

  var rules = _ensureTagThenStyles2.slice(1);

  var styleRoot = new (Function.prototype.bind.apply(_Root2.default, [null].concat(_toConsumableArray(rules))))();
  /* Don't generate the styles now, only on render */
  var className = void 0;

  /* Return a stateless functional component that simply renders
  * a HTML element with our styles applied. */
  return function (props) {
    /* Need to be able to regenerate styles if things change, but for now everything's static */
    if (!className) className = styleRoot.injectStyles();
    return (0, _react.createElement)(tagName, Object.assign({}, props, {
      className: [props.className, className].join(' ')
    }));
  };
};

exports.default = Element;
module.exports = exports['default'];