"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Rule = require("./Rule");

var _Rule2 = _interopRequireDefault(_Rule);

var _MediaQuery = require("./MediaQuery");

var _MediaQuery2 = _interopRequireDefault(_MediaQuery);

var _NestedSelector = require("./NestedSelector");

var _NestedSelector2 = _interopRequireDefault(_NestedSelector);

var _ValidRuleSetChild2 = require("./ValidRuleSetChild");

var _ValidRuleSetChild3 = _interopRequireDefault(_ValidRuleSetChild2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

/*
* A RuleSet stores the leaf nodes that apply to some level
* of a styling tree, as well as any other children (fragments).
* Use concat() to create one easily.
* */

var RuleSet = function (_ValidRuleSetChild) {
  _inherits(RuleSet, _ValidRuleSetChild);

  function RuleSet() {
    _classCallCheck(this, RuleSet);

    var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(RuleSet).call(this));

    _this.rules = [];
    return _this;
  }

  _createClass(RuleSet, [{
    key: "add",
    value: function add() {
      var _this2 = this;

      for (var _len = arguments.length, other = Array(_len), _key = 0; _key < _len; _key++) {
        other[_key] = arguments[_key];
      }

      other.forEach(function (r) {
        var _rules;

        if (!r) return;
        if (r instanceof RuleSet) (_rules = _this2.rules).push.apply(_rules, _toConsumableArray(r.rules));else if (r instanceof _ValidRuleSetChild3.default) _this2.rules.push(r);else {
          console.error(r);
          throw new Error("Can't add this ^ to a RuleSet.");
        }
      });
    }
  }, {
    key: "flatten",
    value: function flatten() {
      var rules = {};
      var fragments = [];
      this.rules.forEach(function (r) {
        if (r instanceof _Rule2.default) {
          rules[r.property] = r.value;
        } else if (r instanceof _MediaQuery2.default) {
          rules[r.fullQuery()] = r.flatten();
        } else if (r instanceof _NestedSelector2.default) {
          fragments.push(r.flatten());
        }
      });

      return { rules: rules, fragments: fragments };
    }
  }]);

  return RuleSet;
}(_ValidRuleSetChild3.default);

exports.default = RuleSet;
module.exports = exports["default"];