'use strict';

var _expect = require('expect');

var _expect2 = _interopRequireDefault(_expect);

var _ = require('./');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

describe('units', function () {
	describe('unit factory', function () {
		it('should create a function when first called', function () {
			var result = (0, _.unit)('vh');
			(0, _expect2.default)(result).toBeA(Function);
		});

		it('should create a function with one argument', function () {
			var result = (0, _.unit)('vh');
			(0, _expect2.default)(result.length).toBe(1);
		});

		it('should create a string from the two arguments to the two functions', function () {
			var unitSuffix = 'vh';
			var unitAmount = 10;
			var unitFactory = (0, _.unit)(unitSuffix);
			var result = unitFactory(unitAmount);
			(0, _expect2.default)(result).toBe('' + unitAmount + unitSuffix);
		});

		it('should create a string with the unit suffix multiple times', function () {
			var unitSuffix = 'vh';
			var unitFactory = (0, _.unit)(unitSuffix);
			var result1 = unitFactory(10);
			var result2 = unitFactory(20);
			(0, _expect2.default)(result1).toBeA('string');
			(0, _expect2.default)(result2).toBeA('string');
		});
	});

	describe('exported units', function () {
		it('should export vh', function () {
			var unitAmount = 10;
			var result = (0, _.vh)(10);
			(0, _expect2.default)(result).toBe(unitAmount + 'vh');
		});

		it('should export vw', function () {
			var unitAmount = 10;
			var result = (0, _.vw)(10);
			(0, _expect2.default)(result).toBe(unitAmount + 'vw');
		});

		it('should export px', function () {
			var unitAmount = 10;
			var result = (0, _.px)(10);
			(0, _expect2.default)(result).toBe(unitAmount + 'px');
		});

		it('should export rem', function () {
			var unitAmount = 10;
			var result = (0, _.rem)(10);
			(0, _expect2.default)(result).toBe(unitAmount + 'rem');
		});

		it('should export em', function () {
			var unitAmount = 10;
			var result = (0, _.em)(10);
			(0, _expect2.default)(result).toBe(unitAmount + 'em');
		});
	});
});